import { TSESTree } from '@typescript-eslint/utils';
import { TypeChecker, TypeNode } from 'typescript';
type Column = 'Column' | 'PrimaryColumn' | 'PrimaryGeneratedColumn' | 'CreateDateColumn' | 'UpdateDateColumn' | 'DeleteDateColumn' | 'VersionColumn';
type ColumnTypeString = 'string' | 'number' | 'boolean' | 'Date' | 'unknown';
export interface ColumnType {
    columnType: ColumnTypeString;
    nullable: boolean;
    literal: boolean;
    array: boolean;
}
interface ColumnParameter {
    type?: string;
    nullable?: boolean;
    transformer?: object;
    array?: boolean;
}
export declare function getDefaultColumnTypeForDecorator(column: Column): ColumnParameter;
export declare function convertArgumentToColumnType(column: Column, args: TSESTree.CallExpressionArgument[], driver?: string): ColumnType;
export declare function convertTsTypeToColumnType(arg: TypeNode, checker: TypeChecker): ColumnType;
export declare function convertTypeToColumnType(arg: TSESTree.TypeNode): ColumnType;
export declare function isTypesEqual(toType: ColumnType, tsType: ColumnType): boolean;
export declare function typeToString(column: ColumnType, { literal, columnType: tsColumnType }: ColumnType): string | undefined;
export {};
